"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRefs = void 0;
const react_1 = require("react");
function useRefs(...refs) {
    const targetRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        [...refs].forEach((ref) => {
            if (!ref)
                return;
            if (typeof ref === 'function')
                return ref(targetRef.current);
            return (ref.current = targetRef.current);
        });
    }, [refs]);
    return targetRef;
}
exports.useRefs = useRefs;
//# sourceMappingURL=use-refs.js.map