/// <reference types="node" />
import { IncomingHttpHeaders } from 'http';
import { GetServerSidePropsContext } from '../types/next';
export declare type TypedHeaders = {
    req: {
        getHeader: (name: keyof IncomingHttpHeaders) => string | undefined;
    };
    res: {
        setHeader: (name: keyof IncomingHttpHeaders, value: string | number | ReadonlyArray<string>) => void;
    };
};
export declare function bindTypedHeaders(context: GetServerSidePropsContext): asserts context is GetServerSidePropsContext & TypedHeaders;
